com.saxonica.expr

## Class JavaExtensionFunctionCall

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.FunctionCall
    - - com.saxonica.expr.JavaExtensionFunctionCall

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, Callable, InstructionInfo, Locator

      public class JavaExtensionFunctionCall
      extends FunctionCall
      implements Callable

  This class acts as a container for an extension function defined to call a method in a user-defined class.

  Note that the binding of an XPath function call to a Java method is done in class `JavaExtensionLibrary`

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `JavaExtensionFunctionCall.ConfigurationCheckingFunction` This class checks that NodeInfo objects returned by an extension function were created under the right Configuration

  - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.FunctionCall

      `argument`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JavaExtensionFunctionCall()` Default constructor

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of this expression to a PathMap.
    `Sequence` | `call(XPathContext context, Sequence[] argValues)` Call an extension function previously identified using the bind() method.
    `void` | `checkArguments(ExpressionVisitor visitor)` Method called by the expression parser when all arguments have been supplied
    `int` | `computeCardinality()` Compute the static cardinality of this expression
    `Expression` | `copy()` Copy an expression.
    `PJConverter[]` | `getArgumentConverters()` Get the converters used to convert the arguments from XPath values to Java values
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the JavaExtensionFunctionCall expression
    `protected Object` | `getField(Field field, Object instance)` Access a field.
    `int` | `getIntrinsicDependencies()` Determine which aspects of the context the expression depends on.
    `ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the expression, if possible.
    `Class[]` | `getParameterTypes()` Get the types of the arguments
    `JPConverter` | `getResultConverter()` Get the converter used to convert the result from a Java object to an XPath value
    `Class` | `getReturnClass()` Get the Java class of the value returned by the method
    `Class` | `getTargetClass()` Get the class containing the method being called
    `AccessibleObject` | `getTargetMethod()` Get the target method (or field, or constructor) being called
    `void` | `init(StructuredQName functionName, Class theClass, AccessibleObject object, Configuration config)` Initialization: creates an ExtensionFunctionCall
    `protected Object` | `invokeConstructor(Constructor constructor, Object[] params)` Invoke a constructor.
    `protected Object` | `invokeMethod(Method method, Object instance, Object[] params)` Invoke a method.
    `boolean` | `isNodeCheckRequired()` Ask whether the result needs to be checked to ensure it contains no nodes from the wrong Configuration
    `boolean` | `isSubtreeExpression()` Determine whether the expression can be evaluated without reference to the part of the context document outside the subtree rooted at the context node.
    `SequenceIterator` | `iterate(XPathContext context)` Evaluate the function.
    `Expression` | `preEvaluate(ExpressionVisitor visitor)` preEvaluate: this method suppresses compile-time evaluation by doing nothing (because the external function might have side-effects and might use the context)
    `void` | `prepareForDynamicCall(Configuration config)`
    `static String` | `toCamelCase(String name, boolean debug, PrintStream diag)` Convert a name to camelCase (by removing hyphens and changing the following letter to capitals)
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the expression.

    - ### Methods inherited from class net.sf.saxon.expr.FunctionCall

      `addExternalFunctionCallToPathMap, checkArgumentCount, equals, explain, getArguments, getDisplayName, getExpressionName, getFunctionName, getNumberOfArguments, hashCode, iterateSubExpressions, optimize, promote, replaceSubExpression, setArguments, setFunctionName, simplify, simplifyArguments, toString`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeSpecialProperties, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getImplementationMethod, getIntegerBounds, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getStreamingAdjunct, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isUpdatingExpression, isVacuousExpression, iterateEvents, iterateSubExpressionInfo, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### JavaExtensionFunctionCall

          public JavaExtensionFunctionCall()

      Default constructor

  - ### Method Detail

    - #### init

          public void init(StructuredQName functionName,
                  Class theClass,
                  AccessibleObject object,
                  Configuration config)

      Initialization: creates an ExtensionFunctionCall
      Parameters:
        `functionName` - the name of the function, for display purposes
        `theClass` - the Java class containing the method to be called
        `object` - the method, field, or constructor of the Java class to be called
        `config` - the Saxon configuration

    - #### preEvaluate

          public Expression preEvaluate(ExpressionVisitor visitor)

      preEvaluate: this method suppresses compile-time evaluation by doing nothing (because the external function might have side-effects and might use the context)
      Overrides:
        `preEvaluate` in class `FunctionCall`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the result of the early evaluation, or the original expression, or potentially a simplified expression

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      Description copied from class: `FunctionCall`
      Type-check the expression. This also calls preEvaluate() to evaluate the function if all the arguments are constant; functions that do not require this behavior can override the preEvaluate method.
      Overrides:
        `typeCheck` in class `FunctionCall`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### prepareForDynamicCall

          public void prepareForDynamicCall(Configuration config)
                                     throws XPathException

      Throws:
        `XPathException`

    - #### checkArguments

          public void checkArguments(ExpressionVisitor visitor)
                              throws XPathException

      Method called by the expression parser when all arguments have been supplied
      Specified by:
        `checkArguments` in class `FunctionCall`
      Parameters:
        `visitor` - the expression visitor
      Throws:
        `XPathException` - if the arguments are incorrect

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Returns:
        the copy of the original expression

    - #### getIntrinsicDependencies

          public int getIntrinsicDependencies()

      Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE
      Overrides:
        `getIntrinsicDependencies` in class `Expression`
      Returns:
        a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

    - #### isSubtreeExpression

          public boolean isSubtreeExpression()

      Determine whether the expression can be evaluated without reference to the part of the context document outside the subtree rooted at the context node.
      Overrides:
        `isSubtreeExpression` in class `Expression`
      Returns:
        true if the expression has no dependencies on the context node, or if the only dependencies on the context node are downward selections using the self, child, descendant, attribute, and namespace axes.

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                            PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

      The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the PathMapNodeSet to which the paths embodied in this expression should be added
      Returns:
        the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

    - #### isNodeCheckRequired

          public boolean isNodeCheckRequired()

      Ask whether the result needs to be checked to ensure it contains no nodes from the wrong Configuration
      Returns:
        true if the result needs to be checked

    - #### iterate

          public SequenceIterator iterate(XPathContext context)
                                   throws XPathException

      Evaluate the function.
      Overrides:
        `iterate` in class `Expression`
      Parameters:
        `context` - The context in which the function is to be evaluated
      Returns:
        a Value representing the result of the function.
      Throws:
        `XPathException` - if the function cannot be evaluated.

    - #### getTargetClass

          public Class getTargetClass()

      Get the class containing the method being called
      Returns:
        the class containing the target method

    - #### getTargetMethod

          public AccessibleObject getTargetMethod()

      Get the target method (or field, or constructor) being called
      Returns:
        the target method, field, or constructor

    - #### getParameterTypes

          public Class[] getParameterTypes()

      Get the types of the arguments
      Returns:
        an array of classes representing the declared types of the arguments to the method or constructor

    - #### call

          public Sequence call(XPathContext context,
                      Sequence[] argValues)
                        throws XPathException

      Call an extension function previously identified using the bind() method. A subclass can override this method.
      Specified by:
        `call` in interface `Callable`
      Parameters:
        `context` - The XPath dynamic evaluation context
        `argValues` - The values of the arguments
      Returns:
        The value returned by the extension function
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the expression

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Determine the data type of the expression, if possible. All expressions return sequences, in general; this method determines the type of the items within the sequence, assuming that (a) this is known in advance, and (b) it is the same for all items in the sequence.

      This method will always return a result, though it may be the best approximation that is available at the time.

      Specified by:
        `getItemType` in class `Expression`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the item type

    - #### computeCardinality

          public int computeCardinality()

      Description copied from class: `Expression`
      Compute the static cardinality of this expression
      Specified by:
        `computeCardinality` in class `Expression`
      Returns:
        the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

    - #### getReturnClass

          public Class getReturnClass()

      Get the Java class of the value returned by the method
      Returns:
        the Java class of the value returned by the method

    - #### getArgumentConverters

          public PJConverter[] getArgumentConverters()

      Get the converters used to convert the arguments from XPath values to Java values
      Returns:
        an array of converters, one per argument

    - #### getResultConverter

          public JPConverter getResultConverter()

      Get the converter used to convert the result from a Java object to an XPath value
      Returns:
        the converter that is used

    - #### invokeConstructor

          protected Object invokeConstructor(Constructor constructor,
                                 Object[] params)
                                      throws InstantiationException,
                                             IllegalAccessException,
                                             InvocationTargetException

      Invoke a constructor. This method is provided separately so that it can be refined in a subclass. For example, a subclass might perform tracing of calls, or might trap exceptions.
      Parameters:
        `constructor` - The constructor to be invoked
        `params` - The parameters to be passed to the constructor
      Returns:
        The object returned by the constructor
      Throws:
        `InstantiationException` - if the invocation throws an InstantiationException
        `IllegalAccessException` - if the invocation throws an IllegalAccessException
        `InvocationTargetException` - if the invocation throws an InvocationTargetException (which happens when the constructor itself throws an exception)

    - #### invokeMethod

          protected Object invokeMethod(Method method,
                            Object instance,
                            Object[] params)
                                 throws IllegalAccessException,
                                        InvocationTargetException

      Invoke a method. This method is provided separately so that it can be refined in a subclass. For example, a subclass might perform tracing of calls, or might trap exceptions.
      Parameters:
        `method` - The method to be invoked
        `instance` - The object on which the method is to be invoked. This is set to null if the method is static.
        `params` - The parameters to be passed to the method
      Returns:
        The object returned by the method
      Throws:
        `IllegalAccessException` - if the invocation throws an IllegalAccessException
        `InvocationTargetException` - if the invocation throws an InvocationTargetException (which happens when the method itself throws an exception)

    - #### getField

          protected Object getField(Field field,
                        Object instance)
                             throws IllegalAccessException

      Access a field. This method is provided separately so that it can be refined in a subclass. For example, a subclass might perform tracing of calls, or might trap exceptions.
      Parameters:
        `field` - The field to be retrieved
        `instance` - The object whose field is to be retrieved. This is set to null if the field is static.
      Returns:
        The value of the field
      Throws:
        `IllegalAccessException` - if the invocation throws an IllegalAccessException

    - #### toCamelCase

          public static String toCamelCase(String name,
                           boolean debug,
                           PrintStream diag)

      Convert a name to camelCase (by removing hyphens and changing the following letter to capitals)
      Parameters:
        `name` - the name to be converted to camelCase
        `debug` - true if tracing is required
        `diag` - the output stream for diagnostic trace output
      Returns:
        the camelCased name

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the JavaExtensionFunctionCall expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.